#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>

#ifndef _SVPM_H
#define PM_BOOL BOOL
#endif

#include "pthread.h"

#ifdef __cplusplus
extern "C" {
#endif

ULONG	 TlsAlloc( void);
PM_BOOL	 TlsFree( ULONG);
PVOID	 TlsGetValue( ULONG);
PM_BOOL	 TlsSetValue( ULONG, PVOID);
void      TlsAllocThreadLocalMemory( void);
void      TlsFreeThreadLocalMemory( void);

#ifdef __cplusplus
}
#endif

int pthread_key_create(pthread_key_t *pk, void (*destructor)(void *))
{
  if (!pk) return -1;
  *pk = TlsAlloc();
  return *pk == 0xffffffff;
}

int pthread_key_delete(pthread_key_t k)
{
  return TlsFree(k) ? 0 : -1;
}

int pthread_getspecific(pthread_key_t k)
{
  return (int)(unsigned long)TlsGetValue(k);
}

int pthread_setspecific(pthread_key_t k, const void *v)
{
  return TlsSetValue(k, (PVOID)v) ? 0 : -1;
}

int pthread_yield(void)
{
  DosSleep(0);
  return 0;
}
